OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
juce::dsp::StateVariableFilter::Filter< SampleType > Class Template Reference

`#include <juce_StateVariableFilter.h>`

## Public Types
using | NumericType = typename SampleTypeHelpers::ElementType< SampleType >::Type
using | ParametersPtr = typename Parameters< NumericType >::Ptr

## Public Member Functions
| Filter ()
| Filter (ParametersPtr parametersToUse)
| Filter (const Filter &)=default
| Filter (Filter &&)=default
void | prepare (const ProcessSpec &) noexcept
void | reset () noexcept
void | snapToZero () noexcept
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
SampleType JUCE_VECTOR_CALLTYPE | processSample (SampleType sample) noexcept

## Public Attributes
Parameters< NumericType >::Ptr | parameters

## Detailed Description

template<typename SampleType>
class juce::dsp::StateVariableFilter::Filter< SampleType >

An IIR filter that can perform low, band and high-pass filtering on an audio signal, with 12 dB of attenuation / octave, using a TPT structure, designed for fast modulation (see Vadim Zavalishin's documentation about TPT structures for more information). Its behaviour is based on the analog state variable filter circuit.

Note: The bandpass here is not the one in the RBJ CookBook, its gain can be higher than 0 dB. For the classic 0 dB bandpass, we need to multiply the result with R2

Definition at line 54 of file juce_StateVariableFilter.h.

## Member Typedef Documentation

## ◆ NumericType

template<typename SampleType >

using juce::dsp::StateVariableFilter::Filter< SampleType >::NumericType = typename SampleTypeHelpers::ElementType<SampleType>::Type

The NumericType is the underlying primitive type used by the SampleType (which could be either a primitive or vector)

Definition at line 61 of file juce_StateVariableFilter.h.

## ◆ ParametersPtr

template<typename SampleType >

using juce::dsp::StateVariableFilter::Filter< SampleType >::ParametersPtr = typename Parameters<NumericType>::Ptr

A typedef for a ref-counted pointer to the coefficients object

Definition at line 64 of file juce_StateVariableFilter.h.

## Constructor & Destructor Documentation

## ◆ Filter() [1/4]

template<typename SampleType >

juce::dsp::StateVariableFilter::Filter< SampleType >::Filter | ( |  | ) |
| inline

Creates a filter with default parameters.

Definition at line 68 of file juce_StateVariableFilter.h.

## ◆ Filter() [2/4]

template<typename SampleType >

juce::dsp::StateVariableFilter::Filter< SampleType >::Filter | ( | ParametersPtr | parametersToUse | ) |
| inline

Definition at line 70 of file juce_StateVariableFilter.h.

## ◆ Filter() [3/4]

template<typename SampleType >

juce::dsp::StateVariableFilter::Filter< SampleType >::Filter | ( | const Filter< SampleType > & |  | ) |
| default

Creates a copy of another filter.

## ◆ Filter() [4/4]

template<typename SampleType >

juce::dsp::StateVariableFilter::Filter< SampleType >::Filter | ( | Filter< SampleType > && |  | ) |
| default

Move constructor

## Member Function Documentation

## ◆ prepare()

template<typename SampleType >

void juce::dsp::StateVariableFilter::Filter< SampleType >::prepare | ( | const ProcessSpec & |  | ) |
| inline noexcept

Initialization of the filter

Definition at line 80 of file juce_StateVariableFilter.h.

## ◆ process()

template<typename SampleType >
template<typename ProcessContext >

void juce::dsp::StateVariableFilter::Filter< SampleType >::process | ( | const ProcessContext & | context | ) |
| inline noexcept

Definition at line 98 of file juce_StateVariableFilter.h.

## ◆ processSample()

template<typename SampleType >

SampleType JUCE_VECTOR_CALLTYPE juce::dsp::StateVariableFilter::Filter< SampleType >::processSample | ( | SampleType | sample | ) |
| inline noexcept

Processes a single sample, without any locking or checking. Use this if you need processing of a single value.

Definition at line 111 of file juce_StateVariableFilter.h.

## ◆ reset()

template<typename SampleType >

void juce::dsp::StateVariableFilter::Filter< SampleType >::reset | ( |  | ) |
| inline noexcept

Resets the filter's processing pipeline.

Definition at line 83 of file juce_StateVariableFilter.h.

Referenced by juce::dsp::StateVariableFilter::Filter< SampleType >::Filter(), and juce::dsp::StateVariableFilter::Filter< SampleType >::prepare().

## ◆ snapToZero()

template<typename SampleType >

void juce::dsp::StateVariableFilter::Filter< SampleType >::snapToZero | ( |  | ) |
| inline noexcept

Ensure that the state variables are rounded to zero if the state variables are denormals. This is only needed if you are doing sample by sample processing.

Definition at line 89 of file juce_StateVariableFilter.h.

## Member Data Documentation

## ◆ parameters

template<typename SampleType >

Parameters<NumericType>::Ptr juce::dsp::StateVariableFilter::Filter< SampleType >::parameters

The parameters of the state variable filter. It's up to the caller to ensure that these parameters are modified in a thread-safe way.

Definition at line 94 of file juce_StateVariableFilter.h.

Referenced by juce::dsp::StateVariableFilter::Filter< SampleType >::processSample().

The documentation for this class was generated from the following file:

- juce_StateVariableFilter.h